﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SunCRC.Crc.Crc1_64
{
    /// <summary>
    /// Information taken from http://reveng.sourceforge.net/crc-catalogue/
    /// </summary>
    class Crc1_64Database
    {
        /* crcSize, polynomial, initialVal, inputReflected, resultReflected, finalXorVal, name */
        public static Crc1_64Model CRC3_GSM = new Crc1_64Model(3, 0x3, 0x0, false, false, 0x7, "CRC3_GSM");
        public static Crc1_64Model CRC3_ROHC = new Crc1_64Model(3, 0x3, 0x7, true, true, 0x0, "CRC3_ROHC");
        public static Crc1_64Model CRC4_G704 = new Crc1_64Model(4, 0x3, 0x0, true, true, 0x0, "CRC4_G704");
        public static Crc1_64Model CRC4_INTERLAKEN = new Crc1_64Model(4, 0x3, 0xf, false, false, 0xf, "CRC4_INTERLAKEN");
        public static Crc1_64Model CRC5_EPCC1G2 = new Crc1_64Model(5, 0x09, 0x09, false, false, 0x00, "CRC5_EPCC1G2");
        public static Crc1_64Model CRC5_G704 = new Crc1_64Model(5, 0x15, 0x00, true, true, 0x00, "CRC5_G704");
        public static Crc1_64Model CRC5_USB = new Crc1_64Model(5, 0x05, 0x1f, true, true, 0x1f, "CRC5_USB");
        public static Crc1_64Model CRC6_CDMA2000A = new Crc1_64Model(6, 0x27, 0x3f, false, false, 0x00, "CRC6_CDMA2000A");
        public static Crc1_64Model CRC6_CDMA2000B = new Crc1_64Model(6, 0x07, 0x3f, false, false, 0x00, "CRC6_CDMA2000B");
        public static Crc1_64Model CRC6_DARC = new Crc1_64Model(6, 0x19, 0x00, true, true, 0x00, "CRC6_DARC");
        public static Crc1_64Model CRC6_G704 = new Crc1_64Model(6, 0x03, 0x00, true, true, 0x00, "CRC6_G704");
        public static Crc1_64Model CRC6_GSM = new Crc1_64Model(6, 0x2f, 0x00, false, false, 0x3f, "CRC6_GSM");
        public static Crc1_64Model CRC7_MMC = new Crc1_64Model(7, 0x09, 0x00, false, false, 0x00, "CRC7_MMC");
        public static Crc1_64Model CRC7_ROHC = new Crc1_64Model(7, 0x4f, 0x7f, true, true, 0x00, "CRC7_ROHC");
        public static Crc1_64Model CRC7_UMTS = new Crc1_64Model(7, 0x45, 0x00, false, false, 0x00, "CRC7_UMTS");
        public static Crc1_64Model CRC8_AUTOSAR = new Crc1_64Model(8, 0x2f, 0xff, false, false, 0xff, "CRC8_AUTOSAR");
        public static Crc1_64Model CRC8_BLUETOOTH = new Crc1_64Model(8, 0xa7, 0x00, true, true, 0x00, "CRC8_BLUETOOTH");
        public static Crc1_64Model CRC8_CDMA2000 = new Crc1_64Model(8, 0x9b, 0xff, false, false, 0x00, "CRC8_CDMA2000");
        public static Crc1_64Model CRC8_DARC = new Crc1_64Model(8, 0x39, 0x00, true, true, 0x00, "CRC8_DARC");
        public static Crc1_64Model CRC8_DVBS2 = new Crc1_64Model(8, 0xd5, 0x00, false, false, 0x00, "CRC8_DVBS2");
        public static Crc1_64Model CRC8_GSMA = new Crc1_64Model(8, 0x1d, 0x00, false, false, 0x00, "CRC8_GSMA");
        public static Crc1_64Model CRC8_GSMB = new Crc1_64Model(8, 0x49, 0x00, false, false, 0xff, "CRC8_GSMB");
        public static Crc1_64Model CRC8_HITAG = new Crc1_64Model(8, 0x1d, 0xff, false, false, 0x00, "CRC8_HITAG");
        public static Crc1_64Model CRC8_I4321 = new Crc1_64Model(8, 0x07, 0x00, false, false, 0x55, "CRC8_I4321");
        public static Crc1_64Model CRC8_ICODE = new Crc1_64Model(8, 0x1d, 0xfd, false, false, 0x00, "CRC8_ICODE");
        public static Crc1_64Model CRC8_LTE = new Crc1_64Model(8, 0x9b, 0x00, false, false, 0x00, "CRC8_LTE");
        public static Crc1_64Model CRC8_MAXIMDOW = new Crc1_64Model(8, 0x31, 0x00, true, true, 0x00, "CRC8_MAXIMDOW");
        public static Crc1_64Model CRC8_MIFAREMAD = new Crc1_64Model(8, 0x1d, 0xc7, false, false, 0x00, "CRC8_MIFAREMAD");
        public static Crc1_64Model CRC8_NRSC5 = new Crc1_64Model(8, 0x31, 0xff, false, false, 0x00, "CRC8_NRSC5");
        public static Crc1_64Model CRC8_OPENSAFETY = new Crc1_64Model(8, 0x2f, 0x00, false, false, 0x00, "CRC8_OPENSAFETY");
        public static Crc1_64Model CRC8_ROHC = new Crc1_64Model(8, 0x07, 0xff, true, true, 0x00, "CRC8_ROHC");
        public static Crc1_64Model CRC8_SAEJ1850 = new Crc1_64Model(8, 0x1d, 0xff, false, false, 0xff, "CRC8_SAEJ1850");
        public static Crc1_64Model CRC8_SMBUS = new Crc1_64Model(8, 0x07, 0x00, false, false, 0x00, "CRC8_SMBUS");
        public static Crc1_64Model CRC8_TECH3250 = new Crc1_64Model(8, 0x1d, 0xff, true, true, 0x00, "CRC8_TECH3250");
        public static Crc1_64Model CRC8_WCDMA = new Crc1_64Model(8, 0x9b, 0x00, true, true, 0x00, "CRC8_WCDMA");
        public static Crc1_64Model CRC10_ATM = new Crc1_64Model(10, 0x233, 0x000, false, false, 0x000, "CRC10_ATM");
        public static Crc1_64Model CRC10_CDMA2000 = new Crc1_64Model(10, 0x3d9, 0x3ff, false, false, 0x000, "CRC10_CDMA2000");
        public static Crc1_64Model CRC10_GSM = new Crc1_64Model(10, 0x175, 0x000, false, false, 0x3ff, "CRC10_GSM");
        public static Crc1_64Model CRC11_FLEXRAY = new Crc1_64Model(11, 0x385, 0x01a, false, false, 0x000, "CRC11_FLEXRAY");
        public static Crc1_64Model CRC11_UMTS = new Crc1_64Model(11, 0x307, 0x000, false, false, 0x000, "CRC11_UMTS");
        public static Crc1_64Model CRC12_CDMA2000 = new Crc1_64Model(12, 0xf13, 0xfff, false, false, 0x000, "CRC12_CDMA2000");
        public static Crc1_64Model CRC12_DECT = new Crc1_64Model(12, 0x80f, 0x000, false, false, 0x000, "CRC12_DECT");
        public static Crc1_64Model CRC12_GSM = new Crc1_64Model(12, 0xd31, 0x000, false, false, 0xfff, "CRC12_GSM");
        public static Crc1_64Model CRC12_UMTS = new Crc1_64Model(12, 0x80f, 0x000, false, true, 0x000, "CRC12_UMTS");
        public static Crc1_64Model CRC13_BBC = new Crc1_64Model(13, 0x1cf5, 0x0000, false, false, 0x0000, "CRC13_BBC");
        public static Crc1_64Model CRC14_DARC = new Crc1_64Model(14, 0x0805, 0x0000, true, true, 0x0000, "CRC14_DARC");
        public static Crc1_64Model CRC14_GSM = new Crc1_64Model(14, 0x202d, 0x0000, false, false, 0x3fff, "CRC14_GSM");
        public static Crc1_64Model CRC15_CAN = new Crc1_64Model(15, 0x4599, 0x0000, false, false, 0x0000, "CRC15_CAN");
        public static Crc1_64Model CRC15_MPT1327 = new Crc1_64Model(15, 0x6815, 0x0000, false, false, 0x0001, "CRC15_MPT1327");
        public static Crc1_64Model CRC16_ARC = new Crc1_64Model(16, 0x8005, 0x0000, true, true, 0x0000, "CRC16_ARC");
        public static Crc1_64Model CRC16_CDMA2000 = new Crc1_64Model(16, 0xc867, 0xffff, false, false, 0x0000, "CRC16_CDMA2000");
        public static Crc1_64Model CRC16_CMS = new Crc1_64Model(16, 0x8005, 0xffff, false, false, 0x0000, "CRC16_CMS");
        public static Crc1_64Model CRC16_DDS110 = new Crc1_64Model(16, 0x8005, 0x800d, false, false, 0x0000, "CRC16_DDS110");
        public static Crc1_64Model CRC16_DECTR = new Crc1_64Model(16, 0x0589, 0x0000, false, false, 0x0001, "CRC16_DECTR");
        public static Crc1_64Model CRC16_DECTX = new Crc1_64Model(16, 0x0589, 0x0000, false, false, 0x0000, "CRC16_DECTX");
        public static Crc1_64Model CRC16_DNP = new Crc1_64Model(16, 0x3d65, 0x0000, true, true, 0xffff, "CRC16_DNP");
        public static Crc1_64Model CRC16_EN13757 = new Crc1_64Model(16, 0x3d65, 0x0000, false, false, 0xffff, "CRC16_EN13757");
        public static Crc1_64Model CRC16_GENIBUS = new Crc1_64Model(16, 0x1021, 0xffff, false, false, 0xffff, "CRC16_GENIBUS");
        public static Crc1_64Model CRC16_GSM = new Crc1_64Model(16, 0x1021, 0x0000, false, false, 0xffff, "CRC16_GSM");
        public static Crc1_64Model CRC16_IBM3740 = new Crc1_64Model(16, 0x1021, 0xffff, false, false, 0x0000, "CRC16_IBM3740");
        public static Crc1_64Model CRC16_IBMSDLC = new Crc1_64Model(16, 0x1021, 0xffff, true, true, 0xffff, "CRC16_IBMSDLC");
        public static Crc1_64Model CRC16_ISOIEC144433A = new Crc1_64Model(16, 0x1021, 0xc6c6, true, true, 0x0000, "CRC16_ISOIEC144433A");
        public static Crc1_64Model CRC16_KERMIT = new Crc1_64Model(16, 0x1021, 0x0000, true, true, 0x0000, "CRC16_KERMIT");
        public static Crc1_64Model CRC16_LJ1200 = new Crc1_64Model(16, 0x6f63, 0x0000, false, false, 0x0000, "CRC16_LJ1200");
        public static Crc1_64Model CRC16_M17 = new Crc1_64Model(16, 0x5935, 0xffff, false, false, 0x0000, "CRC16_M17");
        public static Crc1_64Model CRC16_MAXIMDOW = new Crc1_64Model(16, 0x8005, 0x0000, true, true, 0xffff, "CRC16_MAXIMDOW");
        public static Crc1_64Model CRC16_MCRF4XX = new Crc1_64Model(16, 0x1021, 0xffff, true, true, 0x0000, "CRC16_MCRF4XX");
        public static Crc1_64Model CRC16_MODBUS = new Crc1_64Model(16, 0x8005, 0xffff, true, true, 0x0000, "CRC16_MODBUS");
        public static Crc1_64Model CRC16_NRSC5 = new Crc1_64Model(16, 0x080b, 0xffff, true, true, 0x0000, "CRC16_NRSC5");
        public static Crc1_64Model CRC16_OPENSAFETYA = new Crc1_64Model(16, 0x5935, 0x0000, false, false, 0x0000, "CRC16_OPENSAFETYA");
        public static Crc1_64Model CRC16_OPENSAFETYB = new Crc1_64Model(16, 0x755b, 0x0000, false, false, 0x0000, "CRC16_OPENSAFETYB");
        public static Crc1_64Model CRC16_PROFIBUS = new Crc1_64Model(16, 0x1dcf, 0xffff, false, false, 0xffff, "CRC16_PROFIBUS");
        public static Crc1_64Model CRC16_RIELLO = new Crc1_64Model(16, 0x1021, 0xb2aa, true, true, 0x0000, "CRC16_RIELLO");
        public static Crc1_64Model CRC16_SPIFUJITSU = new Crc1_64Model(16, 0x1021, 0x1d0f, false, false, 0x0000, "CRC16_SPIFUJITSU");
        public static Crc1_64Model CRC16_T10DIF = new Crc1_64Model(16, 0x8bb7, 0x0000, false, false, 0x0000, "CRC16_T10DIF");
        public static Crc1_64Model CRC16_TELEDISK = new Crc1_64Model(16, 0xa097, 0x0000, false, false, 0x0000, "CRC16_TELEDISK");
        public static Crc1_64Model CRC16_TMS37157 = new Crc1_64Model(16, 0x1021, 0x89ec, true, true, 0x0000, "CRC16_TMS37157");
        public static Crc1_64Model CRC16_UMTS = new Crc1_64Model(16, 0x8005, 0x0000, false, false, 0x0000, "CRC16_UMTS");
        public static Crc1_64Model CRC16_USB = new Crc1_64Model(16, 0x8005, 0xffff, true, true, 0xffff, "CRC16_USB");
        public static Crc1_64Model CRC16_XMODEM = new Crc1_64Model(16, 0x1021, 0x0000, false, false, 0x0000, "CRC16_XMODEM");
        public static Crc1_64Model CRC17_CANFD = new Crc1_64Model(17, 0x1685b, 0x00000, false, false, 0x00000, "CRC17_CANFD");
        public static Crc1_64Model CRC21_CANFD = new Crc1_64Model(21, 0x102899, 0x000000, false, false, 0x000000, "CRC21_CANFD");
        public static Crc1_64Model CRC24_BLE = new Crc1_64Model(24, 0x00065b, 0x555555, true, true, 0x000000, "CRC24_BLE");
        public static Crc1_64Model CRC24_FLEXRAYA = new Crc1_64Model(24, 0x5d6dcb, 0xfedcba, false, false, 0x000000, "CRC24_FLEXRAYA");
        public static Crc1_64Model CRC24_FLEXRAYB = new Crc1_64Model(24, 0x5d6dcb, 0xabcdef, false, false, 0x000000, "CRC24_FLEXRAYB");
        public static Crc1_64Model CRC24_INTERLAKEN = new Crc1_64Model(24, 0x328b63, 0xffffff, false, false, 0xffffff, "CRC24_INTERLAKEN");
        public static Crc1_64Model CRC24_LTEA = new Crc1_64Model(24, 0x864cfb, 0x000000, false, false, 0x000000, "CRC24_LTEA");
        public static Crc1_64Model CRC24_LTEB = new Crc1_64Model(24, 0x800063, 0x000000, false, false, 0x000000, "CRC24_LTEB");
        public static Crc1_64Model CRC24_OPENPGP = new Crc1_64Model(24, 0x864cfb, 0xb704ce, false, false, 0x000000, "CRC24_OPENPGP");
        public static Crc1_64Model CRC24_OS9 = new Crc1_64Model(24, 0x800063, 0xffffff, false, false, 0xffffff, "CRC24_OS9");
        public static Crc1_64Model CRC30_CDMA = new Crc1_64Model(30, 0x2030b9c7, 0x3fffffff, false, false, 0x3fffffff, "CRC30_CDMA");
        public static Crc1_64Model CRC31_PHILIPS = new Crc1_64Model(31, 0x04c11db7, 0x7fffffff, false, false, 0x7fffffff, "CRC31_PHILIPS");
        public static Crc1_64Model CRC32_AIXM = new Crc1_64Model(32, 0x814141ab, 0x00000000, false, false, 0x00000000, "CRC32_AIXM");
        public static Crc1_64Model CRC32_AUTOSAR = new Crc1_64Model(32, 0xf4acfb13, 0xffffffff, true, true, 0xffffffff, "CRC32_AUTOSAR");
        public static Crc1_64Model CRC32_BASE91D = new Crc1_64Model(32, 0xa833982b, 0xffffffff, true, true, 0xffffffff, "CRC32_BASE91D");
        public static Crc1_64Model CRC32_BZIP2 = new Crc1_64Model(32, 0x04c11db7, 0xffffffff, false, false, 0xffffffff, "CRC32_BZIP2");
        public static Crc1_64Model CRC32_CDROMEDC = new Crc1_64Model(32, 0x8001801b, 0x00000000, true, true, 0x00000000, "CRC32_CDROMEDC");
        public static Crc1_64Model CRC32_CKSUM = new Crc1_64Model(32, 0x04c11db7, 0x00000000, false, false, 0xffffffff, "CRC32_CKSUM");
        public static Crc1_64Model CRC32_ISCSI = new Crc1_64Model(32, 0x1edc6f41, 0xffffffff, true, true, 0xffffffff, "CRC32_ISCSI");
        public static Crc1_64Model CRC32_ISOHDLC = new Crc1_64Model(32, 0x04c11db7, 0xffffffff, true, true, 0xffffffff, "CRC32_ISOHDLC");
        public static Crc1_64Model CRC32_JAMCRC = new Crc1_64Model(32, 0x04c11db7, 0xffffffff, true, true, 0x00000000, "CRC32_JAMCRC");
        public static Crc1_64Model CRC32_MEF = new Crc1_64Model(32, 0x741b8cd7, 0xffffffff, true, true, 0x00000000, "CRC32_MEF");
        public static Crc1_64Model CRC32_MPEG2 = new Crc1_64Model(32, 0x04c11db7, 0xffffffff, false, false, 0x00000000, "CRC32_MPEG2");
        public static Crc1_64Model CRC32_XFER = new Crc1_64Model(32, 0x000000af, 0x00000000, false, false, 0x00000000, "CRC32_XFER");
        public static Crc1_64Model CRC40_GSM = new Crc1_64Model(40, 0x0004820009, 0x0000000000, false, false, 0xffffffffff, "CRC40_GSM");
        public static Crc1_64Model CRC64_ECMA182 = new Crc1_64Model(64, 0x42f0e1eba9ea3693, 0x0000000000000000, false, false, 0x0000000000000000, "CRC64_ECMA182");
        public static Crc1_64Model CRC64_GOISO = new Crc1_64Model(64, 0x000000000000001b, 0xffffffffffffffff, true, true, 0xffffffffffffffff, "CRC64_GOISO");
        public static Crc1_64Model CRC64_MS = new Crc1_64Model(64, 0x259c84cba6426349, 0xffffffffffffffff, true, true, 0x0000000000000000, "CRC64_MS");
        public static Crc1_64Model CRC64_REDIS = new Crc1_64Model(64, 0xad93d23594c935a9, 0x0000000000000000, true, true, 0x0000000000000000, "CRC64_REDIS");
        public static Crc1_64Model CRC64_WE = new Crc1_64Model(64, 0x42f0e1eba9ea3693, 0xffffffffffffffff, false, false, 0xffffffffffffffff, "CRC64_WE");
        public static Crc1_64Model CRC64_XZ = new Crc1_64Model(64, 0x42f0e1eba9ea3693, 0xffffffffffffffff, true, true, 0xffffffffffffffff, "CRC64_XZ");
    }
}
